<?php

namespace Litepci\Engagement;

use User;

class Engagement
{
    /**
     * $engagement object.
     */
    protected $engagement;

    /**
     * Constructor.
     */
    public function __construct(\Litepci\Engagement\Interfaces\EngagementRepositoryInterface $engagement)
    {
        $this->engagement = $engagement;
    }

    /**
     * Returns count of engagement.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.engagement.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->engagement->pushCriteria(new \Litepie\Litepci\Repositories\Criteria\EngagementUserCriteria());
        }

        $engagement = $this->engagement->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('engagement::' . $view, compact('engagement'))->render();
    }
}
