<?php

namespace Litepci\Engagement\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class EngagementTransformer extends TransformerAbstract
{
    public function transform(\Litepci\Engagement\Models\Engagement $engagement)
    {
        return [
            'id'                => $engagement->getRouteKey(),
            'key'               => [
                'public'    => $engagement->getPublicKey(),
                'route'     => $engagement->getRouteKey(),
            ], 
            'id'                => $engagement->id,
            'title'             => $engagement->title,
            'user_type'         => $engagement->user_type,
            'created_at'        => $engagement->created_at,
            'updated_at'        => $engagement->updated_at,
            'deleted_at'        => $engagement->deleted_at,
            'url'               => [
                'public'    => trans_url('engagement/'.$engagement->getPublicKey()),
                'user'      => guard_url('engagement/engagement/'.$engagement->getRouteKey()),
            ], 
            'status'            => trans('app.'.$engagement->status),
            'created_at'        => format_date($engagement->created_at),
            'updated_at'        => format_date($engagement->updated_at),
        ];
    }
}